Retrieve information for all calls

A code snippet that shows how to retrieve information for all calls.

Example

Prerequisites

Execute the following command at your terminal prompt to create the JWT for authentication:

export JWT=$(nexmo jwt:generate $PATH_TO_PRIVATE_KEY application_id=$NEXMO_APPLICATION_ID)

Write the code

Add the following to retrieve-info-for-all-calls.sh:

curl "https://api.nexmo.com/v1/calls" \
  -H "Authorization: Bearer $JWT" \

View full source

Run your code

Save this file to your machine and run it:

bash retrieve-info-for-all-calls.sh

Prerequisites

npm install @vonage/server-sdk

Create a file named retrieve-info-for-all-calls.js and add the following code:

const { Vonage } = require('@vonage/server-sdk');

const vonage = new Vonage({
  applicationId: VONAGE_APPLICATION_ID,
  privateKey: VONAGE_PRIVATE_KEY,
});

View full source

Write the code

Add the following to retrieve-info-for-all-calls.js:

const getCalls = async () => {
  try {
    for await (const call of vonage.voice.getAllCalls()) {
      console.log(call);
    }
  } catch (error) {
    console.error(error);
  }
};

getCalls();

View full source

Run your code

Save this file to your machine and run it:

node retrieve-info-for-all-calls.js

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk-kotlin:2.1.1'

Create a file named RetrieveInfoForAllCalls and add the following code to the main method:

val client = Vonage {
    applicationId(VONAGE_APPLICATION_ID)
    privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
}

View full source

Write the code

Add the following to the main method of the RetrieveInfoForAllCalls file:

val now = Instant.now()
val yesterday = now.minus(Duration.ofDays(1))

val calls = client.voice.listCalls {
    startDate(yesterday)
    endDate(now)
}

calls.callInfos.forEach {
    println(it.toJson())
}

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.kt.voice with the package containing RetrieveInfoForAllCalls:

gradle run -Pmain=com.vonage.quickstart.kt.voice.RetrieveInfoForAllCalls

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk:9.3.1'

Create a file named RetrieveInfoForAllCalls and add the following code to the main method:

VonageClient client = VonageClient.builder()
        .applicationId(VONAGE_APPLICATION_ID)
        .privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
        .build();

View full source

Write the code

Add the following to the main method of the RetrieveInfoForAllCalls file:

Instant now = Instant.now(), yesterday = now.minus(Duration.ofDays(1));

CallsFilter filter = CallsFilter.builder()
        .startDate(yesterday)
        .endDate(now)
        .build();

CallInfoPage calls = client.getVoiceClient().listCalls(filter);
calls.forEach(System.out::println);

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.voice with the package containing RetrieveInfoForAllCalls:

gradle run -Pmain=com.vonage.quickstart.voice.RetrieveInfoForAllCalls

Prerequisites

Install-Package Vonage

Write the code

Add the following to ListAllCalls.cs:

var credentials = Credentials.FromAppIdAndPrivateKeyPath(VONAGE_APPLICATION_ID, VONAGE_PRIVATE_KEY_PATH);
var client = new VonageClient(credentials);

var dateEnd = DateTime.UtcNow;
var dateStart = dateEnd.AddDays(-1);
var request = new CallSearchFilter() { DateStart = dateStart, DateEnd = dateEnd};

var response = await client.VoiceClient.GetCallsAsync(request);

View full source

Prerequisites

composer require vonage/client

Write the code

Add the following to index.php:

require_once __DIR__ . '/../../vendor/autoload.php';

$keypair = new \Vonage\Client\Credentials\Keypair(file_get_contents(VONAGE_APPLICATION_PRIVATE_KEY_PATH), VONAGE_APPLICATION_ID);
$client = new \Vonage\Client($keypair);

$filter = new \Vonage\Voice\Filter\VoiceFilter();
$filter->setDateStart(new DateTime('-1 Day'));
$filter->setDateEnd(new DateTime());

/** @var \Vonage\Voice\Call $call */
foreach ($client->voice()->search($filter) as $call) {
    echo json_encode($call->toArray()) . PHP_EOL;
}

View full source

Run your code

Save this file to your machine and run it:

php index.php

Prerequisites

pip install vonage python-dotenv

Write the code

Add the following to retrieve-info-for-all-calls.py:

from vonage import Auth, Vonage
from vonage_voice import ListCallsFilter

client = Vonage(
    Auth(
        application_id=VONAGE_APPLICATION_ID,
        private_key=VONAGE_PRIVATE_KEY,
    )
)

now = datetime.now(timezone.utc)
date_end = now.strftime('%Y-%m-%dT%H:%M:%SZ')
start = now - timedelta(hours=24)
date_start = start.strftime('%Y-%m-%dT%H:%M:%SZ')

calls, _ = client.voice.list_calls(
    ListCallsFilter(date_start=date_start, date_end=date_end)
)

for call in calls:
    pprint(call)

View full source

Run your code

Save this file to your machine and run it:

python voice/retrieve-info-for-all-calls.py

Prerequisites

gem install vonage

Write the code

Add the following to retrieve-info-for-all-calls.rb:

client = Vonage::Client.new(
  application_id: VONAGE_APPLICATION_ID,
  private_key: VONAGE_PRIVATE_KEY
)

now = Time.now
yesterday = now - (3600 * 24)

response = client.voice.list({date_start: yesterday.utc.iso8601, date_end: now.utc.iso8601})

View full source

Run your code

Save this file to your machine and run it:

ruby retrieve-info-for-all-calls.rb

Try it out

Run the example code to retrieve information for all calls.